%our friend Least squares

%Mock data
close all; clear
N=100; lm=0.1;
x=8*rand(N,1)+1; y=2*sin(x)+0.5*randn(N,1);

for d=1:30
    X=ones(N,1); %d=1; %d is degree polyomial fit
    for i=1:d
        X=[X x.^i];
    end
    Y=y;

    %x = A\B solves the system of linear equations A*x = B.
    b1=X\Y;
    b2=lsqminnorm(X,Y);
    b3=inv(X'*X)*X'*Y;
    b4=pinv(X)*Y;
 
    %ridge-Tikohonov version
    XX=[X; sqrt(lm)*eye(d+1,d+1)]; 
    YY=[Y;zeros(d+1,1)];
    b5=lsqminnorm(XX,YY);
    b6=inv(XX'*XX)*XX'*YY;
    b7=pinv(XX)*YY;
    b8=lasso(XX,YY,"Lambda",1.e-3);

    b=b4

    %X*b
    yy=X*b
    norm(X*b-Y)
    norm(XX*b-YY)

    plot(x,y,'.'); xlabel('x'); ylabel('y');
    [xx,i]=sort(x)
    hold on; plot(x,yy,'*r'); plot(xx,yy(i),'r'); 
    yyy=X*b6; plot(x,yyy,'*r'); plot(xx,yyy(i),'g');  hold off
    vb=[b1 b2 b3 b4 b5 b6 b7 b8]
    d
    pause
end
